"""
    Freqtrade API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 2021.12-dev21
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from ftclient.api_client import ApiClient, Endpoint as _Endpoint
from ftclient.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from ftclient.model.available_pairs import AvailablePairs
from ftclient.model.http_validation_error import HTTPValidationError
from ftclient.model.pair_history import PairHistory
from ftclient.model.plot_config import PlotConfig


class CandleDataApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.list_available_pairs_api_v1_available_pairs_get_endpoint = _Endpoint(
            settings={
                'response_type': (AvailablePairs,),
                'auth': [
                    'HTTPBasic',
                    'OAuth2PasswordBearer'
                ],
                'endpoint_path': '/api/v1/available_pairs',
                'operation_id': 'list_available_pairs_api_v1_available_pairs_get',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'timeframe',
                    'stake_currency',
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'timeframe':
                        (str,),
                    'stake_currency':
                        (str,),
                },
                'attribute_map': {
                    'timeframe': 'timeframe',
                    'stake_currency': 'stake_currency',
                },
                'location_map': {
                    'timeframe': 'query',
                    'stake_currency': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.pair_candles_api_v1_pair_candles_get_endpoint = _Endpoint(
            settings={
                'response_type': (PairHistory,),
                'auth': [
                    'HTTPBasic',
                    'OAuth2PasswordBearer'
                ],
                'endpoint_path': '/api/v1/pair_candles',
                'operation_id': 'pair_candles_api_v1_pair_candles_get',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'pair',
                    'timeframe',
                    'limit',
                ],
                'required': [
                    'pair',
                    'timeframe',
                    'limit',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'pair':
                        (str,),
                    'timeframe':
                        (str,),
                    'limit':
                        (int,),
                },
                'attribute_map': {
                    'pair': 'pair',
                    'timeframe': 'timeframe',
                    'limit': 'limit',
                },
                'location_map': {
                    'pair': 'query',
                    'timeframe': 'query',
                    'limit': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.pair_history_api_v1_pair_history_get_endpoint = _Endpoint(
            settings={
                'response_type': (PairHistory,),
                'auth': [
                    'HTTPBasic',
                    'OAuth2PasswordBearer'
                ],
                'endpoint_path': '/api/v1/pair_history',
                'operation_id': 'pair_history_api_v1_pair_history_get',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'pair',
                    'timeframe',
                    'timerange',
                    'strategy',
                ],
                'required': [
                    'pair',
                    'timeframe',
                    'timerange',
                    'strategy',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'pair':
                        (str,),
                    'timeframe':
                        (str,),
                    'timerange':
                        (str,),
                    'strategy':
                        (str,),
                },
                'attribute_map': {
                    'pair': 'pair',
                    'timeframe': 'timeframe',
                    'timerange': 'timerange',
                    'strategy': 'strategy',
                },
                'location_map': {
                    'pair': 'query',
                    'timeframe': 'query',
                    'timerange': 'query',
                    'strategy': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.plot_config_api_v1_plot_config_get_endpoint = _Endpoint(
            settings={
                'response_type': (PlotConfig,),
                'auth': [
                    'HTTPBasic',
                    'OAuth2PasswordBearer'
                ],
                'endpoint_path': '/api/v1/plot_config',
                'operation_id': 'plot_config_api_v1_plot_config_get',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                },
                'attribute_map': {
                },
                'location_map': {
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    def list_available_pairs_api_v1_available_pairs_get(
        self,
        **kwargs
    ):
        """List Available Pairs  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_available_pairs_api_v1_available_pairs_get(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            timeframe (str): [optional]
            stake_currency (str): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            AvailablePairs
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        return self.list_available_pairs_api_v1_available_pairs_get_endpoint.call_with_http_info(**kwargs)

    def pair_candles_api_v1_pair_candles_get(
        self,
        pair,
        timeframe,
        limit,
        **kwargs
    ):
        """Pair Candles  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.pair_candles_api_v1_pair_candles_get(pair, timeframe, limit, async_req=True)
        >>> result = thread.get()

        Args:
            pair (str):
            timeframe (str):
            limit (int):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            PairHistory
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['pair'] = \
            pair
        kwargs['timeframe'] = \
            timeframe
        kwargs['limit'] = \
            limit
        return self.pair_candles_api_v1_pair_candles_get_endpoint.call_with_http_info(**kwargs)

    def pair_history_api_v1_pair_history_get(
        self,
        pair,
        timeframe,
        timerange,
        strategy,
        **kwargs
    ):
        """Pair History  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.pair_history_api_v1_pair_history_get(pair, timeframe, timerange, strategy, async_req=True)
        >>> result = thread.get()

        Args:
            pair (str):
            timeframe (str):
            timerange (str):
            strategy (str):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            PairHistory
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['pair'] = \
            pair
        kwargs['timeframe'] = \
            timeframe
        kwargs['timerange'] = \
            timerange
        kwargs['strategy'] = \
            strategy
        return self.pair_history_api_v1_pair_history_get_endpoint.call_with_http_info(**kwargs)

    def plot_config_api_v1_plot_config_get(
        self,
        **kwargs
    ):
        """Plot Config  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.plot_config_api_v1_plot_config_get(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            PlotConfig
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        return self.plot_config_api_v1_plot_config_get_endpoint.call_with_http_info(**kwargs)

